#include "buzzer.h"

void buzzer_init()
{
    DDRD |= (1 << BUZZER); 
}

void buzzer_clean()
{
	DDRD &= ~(1 << BUZZER);
}

void buzzer_start()
{
	PORTD |= (1 << BUZZER);
}

void buzzer_stop()
{
	/* Opresc buzzer-ul. */
	PORTD &= ~(1 << BUZZER);
}

/* Genereaza o nota folosind buzzer-ul. */
void buzzer_play(int nota)
{
	int perioada_nota = 1000000 / frecventa_nota[nota];
	int i;

	/*
	 * Nu putem folosi variable ca argument pentru functia
	 * _delay_us(), asa ca folosim acest "workaround".
	 */
	buzzer_start();
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	buzzer_stop();
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}

void buzzer_play_move()
{
	int i = 0;

	for (i = 0; i < 10; i++)
		buzzer_play(curr_sound);
	curr_sound ++;
	curr_sound %= NUM_NOTE;
}

void buzzer_play_lost()
{
	int k1, k2, count = 0;

	for (k1 = 0; k1 < 50; k1++) {
		for (k2 = 0; k2 < 8; k2++) {
			buzzer_play(count);
			count ++;
			count %= NUM_NOTE;
		}
		_delay_ms(100);
	}
}

void buzzer_play_win()
{
	int k1, k2;

	for (k1 = 0; k1 < 50; k1++) {
		for (k2 = 0; k2 < 8; k2++) {
			buzzer_play(0);
		}
		_delay_ms(100);
	}
}