#ifndef _BUZZER_H
#define _BUZZER_H

#include "util.h"

#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>

#define BUZZER 	PD4

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8

static int curr_sound = 0;

static int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

void buzzer_init();
void buzzer_clean();
void buzzer_start();
void buzzer_stop();
void buzzer_play(int nota);
void buzzer_play_move();
void buzzer_play_win();
void buzzer_play_lost();

#endif
