#include "design.h"

uint16_t get_color(int32_t value)
{
	uint8_t r, g, b;

	switch(value) {
		case (2):
			r = 0;
			g = 250;
			b = 50;
			break;
		case (4):
			r = 100;
			g = 200;
			b = 40;
			break;
		case (8):
			r = 20;
			g = 150;
			b = 30;
			break;
		case (16):
			r = 40;
			g = 120;
			b = 30;
			break;
		case (32):
			r = 60;
			g = 100;
			b = 25;
			break;
		case (64):
			r = 80;
			g = 80;
			b = 80;
			break;
		case (128):
			r = 100;
			g = 150;
			b = 40;
			break;
		case (256):
			r = 100;
			g = 100;
			b = 30;
			break;
		case (512):
			r = 180;
			g = 50;
			b = 80;
			break;
		case (1024):
			r = 180;
			g = 30;
			b = 0;
			break;
		case (2048):
			r = 255;
			g = 0;
			b = 0;
			break;
		case (4096):
			r = 255;
			g = 0;
			b = 50;
			break;
		case (8192):
			r = 255;
			g = 0;
			b = 100;
			break;
		case (16384):
			r = 255;
			g = 0;
			b = 150;
			break;
		default:
			r = 255;
			g = 0;
			b = value % 100 + 156;
			break;
	}

	return Color565(r , g, b);
}

void draw_cell(struct t_cell cell, int32_t value)
{
	struct t_point p1, p2;
	p1.x = border[cell.x] + 1;
	p1.y = border[cell.y] + 1;
	p2.x = border[cell.x + 1] - 1;
	p2.y = border[cell.y + 1] - 1;
	w_lcd_draw_square(p1, p2, get_color(value), ST7735_BLACK, value);
}

void clean_cell(struct t_cell cell)
{
	struct t_point p1, p2;
	p1.x = border[cell.x] + 1;
	p1.y = border[cell.y] + 1;
	p2.x = border[cell.x + 1] - 1;
	p2.y = border[cell.y + 1] - 1;
	w_lcd_draw_square(p1, p2, Color565(255,255, 255), Color565(255,255, 255), -1);
}

void initial_effect()
{
	int16_t xx, yy, nr_colors = 5, r;
	struct t_point p1, p2;
	uint16_t colors[] = {	ST7735_RED, ST7735_GREEN, ST7735_CYAN,
							ST7735_MAGENTA, ST7735_YELLOW  };

	
	for (xx = 0; xx < N; xx++)
		for (yy = 0; yy < N; yy++) {
			r = rand() % nr_colors;
			p1.x = border[xx] + 1;
			p1.y = border[yy] + 1;
			p2.x = border[xx + 1] - 1;
			p2.y = border[yy + 1] - 1;
			w_lcd_draw_square(p1, p2, colors[r], Color565(255,255, 255), -1);
			_delay_ms(100);
		}
	_delay_ms(250);

	for (yy = 1; yy < N - 1; yy++)
		for (xx = 1; xx < N - 1; xx++) {
			p1.x = border[xx] + 1;
			p1.y = border[yy] + 1;
			p2.x = border[xx + 1] - 1;
			p2.y = border[yy + 1] - 1;
			w_lcd_draw_square(p1, p2, Color565(255,255, 255), Color565(255,255, 255), -1);
			_delay_ms(150);
		}

}
