#ifndef _GAME_H
#define _GAME_H

#include "design.h"
#include "buzzer.h"
#include "util.h"

#define LIMIT 0.35

int32_t gm[N][N];

static enum t_dir ring[RING_SIZE];
static int16_t ring_index = 0;

double axg, ayg, azg, gxds, gyds, gzds;
static int state = 0;

void game_set_direction();
enum t_bool game_start();
void game_init();
void print_game();
int32_t get_value(struct t_cell cell);
enum t_bool check_win();
enum t_bool exists_free_cell();
enum t_bool check_valid_cell(struct t_cell *cell);
enum t_bool gen_rand_cell(struct t_cell *cell);
static void test_ring_mpu();

#endif
